# Lykin Tutorial Series

Author: [@glyph](https://mycelial.technology/)

## Introduction

[lykin](https://git.coopcloud.tech/glyph/lykin) is a tutorial application funded by a Secure Scuttlebutt (SSB) community grant. It is intended to showcase one way in which an SSB client application can be written using the [golgi](https://git.coopcloud.tech/golgi-ssb/golgi) client library. This tutorial series walks the reader through the creation of the lykin application.

## Installments

 - [Part 1: Sbot and Web Server](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_1_sbot_rocket)
 - [Part 2: Subscription Form and Key Validation](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_2_subscribe_form)
 - [Part 3: Database and Follows](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_3_database_follows)
 - [Part 4: Posts and Message Streams](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_4_posts_streams)
 - [Part 5: Task Loop](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_5_task_loop)
 - [Part 6: UI Layout and Peers List](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_6_ui_layout)
 - [Part 7: Latest Posts and Names](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_7_latest_posts)
 - [Part 8: Post List and Post Content](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_8_ui_posts)
 - [Part 9: Read, Unread and Delete](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_9_read_delete)
 - [Part 10: Extension Ideas and Conclusion](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_10_extension_ideas)

## Links

 - [Scuttlebutt Protocol Guide](https://ssbc.github.io/scuttlebutt-protocol-guide/)
 - [Scuttlebutt Treasure Map for Developers](https://dev.scuttlebutt.nz)
 - [golgi: Rust RPC Library](http://golgi.mycelial.technology/)

## Thanks

I am grateful to the Butts who voted to fund this work, all contributors to the [SSBC](https://opencollective.com/secure-scuttlebutt-consortium) and Erick Lavoie (`@elavoie` / `@IgYpd+tCtXnlE2tYX/8rR2AGt+P8svC98WH3MdYAa8Y=.ed25519`) in particular - both for partially funding this work and for developing and overseeing the community grant process.

A big thank you to Daan Wynen (aka. [black-puppydog](https://github.com/black-puppydog)) for providing feedback and fixes for code examples in this tutorial series.

## Contribute

If you wish to support my work on the Rust Scuttlebutt ecosystem, please consider contributing to my [Liberapay account](https://liberapay.com/glyph/).

Contributions to the [Secure Scuttlebutt Consortium OpenCollective](https://opencollective.com/secure-scuttlebutt-consortium) are also encouraged.

## License

This tutorial series is shared under a [Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International (CC BY-NC-SA 4.0)](https://creativecommons.org/licenses/by-nc-sa/4.0/) license, while all code is licensed as MIT.
